=== src/tabbox/CMakeLists.txt ===
# Install the KWin/WindowSwitcher service type
install(FILES kwinwindowswitcher.desktop DESTINATION ${KDE_INSTALL_KSERVICETYPESDIR})
install(FILES kwindesktopswitcher.desktop DESTINATION ${KDE_INSTALL_KSERVICETYPESDIR})
