=== autotests/integration/scripting/CMakeLists.txt ===
integrationTest(NAME testScriptingScreenEdge SRCS screenedge_test.cpp)
integrationTest(WAYLAND_ONLY NAME testMinimizeAllScript SRCS minimizeall_test.cpp)
